// stb_CMIPivotsDaySessionV86.cs 0.0.2 2010:09:19 00:00:00$
// Copyright (c) 2010 stbtrader
// Released under the GNU General Public License
//
// This is CMIPivotsDaySessionV86.cs from http://www.ninjatrader.com/support/forum/local_links.php?action=jump&catid=1&id=136 at 
// http://www.ninjatrader.com/support/forum/local_links_search.php?action=like&linkid=142&catid=1
// adding formula for Steenbarger pivot and probably some bugs too. use therefore for the original.


#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region Global Enums

public enum stb_CMIPlotAlignPDS86 {Left, Right, DoNotPlot}
public enum stb_CMIPivotStylesPDS86 { Floor, Wide, Fibonacci, Camarilla, Woodies, Steenbarger }

#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
	/// <summary>
	/// Daily Session Pivot Points.
    /// This is CMIPivotsDaySessionV86.cs from http://www.ninjatrader.com/support/forum/local_links.php?action=jump&catid=1&id=136 at 
    /// http://www.ninjatrader.com/support/forum/local_links_search.php?action=like&linkid=142&catid=1
    /// adding formula for Steenbarger pivot and probably some bugs too. use therefore for the original.
    /// The original package includes also indicators for current dasy, week and month OHL, daily, weekly and monthly pivots
	/// </summary>
    /// 
 	[Description("stb_CMIPivotsDaySessionV86.")]
	public class stb_CMIPivotsDaySessionV86 : Indicator
	{
		#region Variables
		private	SolidBrush[]		brushes					= { new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black),  
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black),  
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black),
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black),
															new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black),
															new SolidBrush(Color.Black), new SolidBrush(Color.Black)};
		private DateTime			currentDate				= Cbi.Globals.MinDate;
		private DateTime			currentMonth			= Cbi.Globals.MinDate;
		private DateTime			currentWeek				= Cbi.Globals.MinDate;
		private DateTime  			marketTime				= Cbi.Globals.MinDate;
		private	double				currentOpen				= 0;
		private	double				currentHigh				= double.MinValue;
		private	double				currentLow				= double.MaxValue;
		private	double				currentClose			= 0;
		private	double				volSum					= 0;
		private	double				volPriceSum				= 0;
		private Bars				dailyBars				= null;
		private SolidBrush			textBrush				= new SolidBrush(Color.Red);
		private Font				textFont				= new Font("Arial", 12);
		private Font				textFont2				= new Font("Arial", 9);
		private string				errorData1				= "For instruments not listed set Local_Session to \"True\" and enter session times in your local time zone.";
		private string				errorData2				= "Daily Pivots can only be displayed on intraday charts.";
		private	string				errorData3				= "Insufficient historical data to calculate pivots. Please increase chart look back period.";
		private string				errorData4				= "Loading of daily data is incomplete. Please refresh chart via F5 or check daily data.";
		private string				errorData5				= "Pivots shown can be inaccurate on range charts, if indicator is set to \"CalcFromIntradayData\". The error can be as large as the range chosen for the chart.";
		private string				errorData6				= "Session length under chart properties must be an integer multiple of chart period. Session end chosen for pivot indicator converted to local time must equal session end under chart properties.";
		private string				errorData7				= "Session end chosen for pivot indicator converted to local time should be equal to session end under chart properties.";
		private bool				dailyDataNotLoaded		= false;
		private bool				existsHistDailyData		= false;
		private bool				isInitializing			= false;
		private bool				isDailyDataLoaded		= false;
		private Data.PivotRange		pivotRangeType			= PivotRange.Daily;
		private bool				firstPeriod				= true;
        private stb_CMIPlotAlignPDS86 plotLabels            = stb_CMIPlotAlignPDS86.Left;
        private stb_CMIPivotStylesPDS86 pivotFormula        = stb_CMIPivotStylesPDS86.Steenbarger; // _e_ from Floor;
		private bool				sessionOpen				= false;
		private bool				localSession			= false;
		private HLCCalculationMode	priorDayHLC				= HLCCalculationMode.CalcFromIntradayData;
		private double				range					= 0;
		private	double				pp						= 0;
		private	double				r1						= 0;
		private	double				r2						= 0;
		private	double				r3						= 0;
		private	double				r4						= 0;
		private	double				s1						= 0;
		private	double				s2						= 0;
		private	double				s3						= 0;
		private	double				s4						= 0;
		private	double				rmid					= 0;
		private	double				r12mid					= 0;
		private	double				r23mid					= 0;
		private	double				r34mid					= 0;
		private	double				smid					= 0;
		private	double				s12mid					= 0;
		private	double				s23mid					= 0;
		private	double				s34mid					= 0;
		private double				midline					= 0;
		private double				previousVWAP			= 0;
		private double				previousOpen			= 0;
		private double				previousHigh			= 0;
		private double				previousLow				= 0;
		private double				previousClose			= 0;
		private	StringFormat		stringFormatNear		= new StringFormat();
		private	StringFormat		stringFormatCenter		= new StringFormat();
		private	StringFormat		stringFormatFar			= new StringFormat();
		private double				userDefinedOpen			= 0;
		private double				userDefinedHigh			= 0;
		private double				userDefinedLow			= 0;
		private double				userDefinedClose		= 0;
		private bool				useUserDefinedValues	= false;
		private int					width					= 15;
		private int					labelPosition			= 10;
		private bool				instrumentfound			= true;
		private bool				showMidpivots			= false;        // _e_
		private bool				showInstructions		= false;
		private TimeSpan			sessionEnd				= new TimeSpan(0,0,0);
		private TimeSpan			sessionBegin			= new TimeSpan(0,0,0);
		private TimeSpan			sessionLength			= new TimeSpan(0,0,0);
		private TimeSpan			breakLength				= new TimeSpan(0,0,0);
		private bool				chicago					= false;
		private bool				newyork					= false;
		private bool				london					= false;
		private bool				frankfurt				= false;
		private bool				local					= false;
		private bool				intraDaySession			= false;
		private bool				exFOREX					= false;
		private bool				exCMEIndex				= false;
		private bool				exCMEInterest			= false;
		private bool				exCMEForex				= false;
		private bool				exCMEAgri				= false;
		private bool				exNYMEX					= false;
		private bool				exNYBOT					= false;
		private bool				exNYBOTRussell			= false;
		private bool				exIPE					= false;
		private bool				exEUREX					= false;
		private TimeSpan			daySpan					= new TimeSpan(24,0,0);
		private TimeSpan 			endFOREX				= new TimeSpan(17,0,0);
		private TimeSpan			endCMEIndex				= new TimeSpan(15,15,0);
		private TimeSpan			endCMEInterest			= new TimeSpan(16,0,0);
		private TimeSpan			endCMEForex				= new TimeSpan(16,0,0); 
		private TimeSpan			endCMEAgri				= new TimeSpan(13,15,0);
		private TimeSpan			endNYMEX				= new TimeSpan(17,15,0);
		private TimeSpan			endNYBOT				= new TimeSpan(14,30,0);
		private TimeSpan			endNYBOTRussell			= new TimeSpan(18,0,0);
		private TimeSpan			endIPE					= new TimeSpan(18,0,0);
		private TimeSpan			endEUREX				= new TimeSpan(17,30,0);
		private TimeSpan			endLocal				= new TimeSpan(0,0,0);
		private TimeSpan 			beginFOREX				= new TimeSpan(17,0,0);
		private TimeSpan			beginCMEIndex			= new TimeSpan(8,30,0);
		private TimeSpan			beginCMEInterest		= new TimeSpan(17,30,0);
		private TimeSpan			beginCMEForex			= new TimeSpan(17,0,0); 
		private TimeSpan			beginCMEAgri			= new TimeSpan(18,0,0);
		private TimeSpan			beginNYMEX				= new TimeSpan(18,0,0);
		private TimeSpan			beginNYBOT				= new TimeSpan(21,0,0);
		private TimeSpan			beginNYBOTRussell		= new TimeSpan(20,0,0);
		private TimeSpan			beginIPE				= new TimeSpan(20,0,0);
		private TimeSpan			beginEUREX				= new TimeSpan(9,0,0);
		private TimeSpan			beginLocal				= new TimeSpan(0,0,0);
		private  TimeSpan			breakFOREX				= new TimeSpan(0,0,0);
		private  TimeSpan			breakCMEIndex			= new TimeSpan(0,15,0);
		private  TimeSpan			breakCMEInterest		= new TimeSpan(1,30,0);
		private  TimeSpan			breakCMEForex			= new TimeSpan(1,0,0);
		private  TimeSpan			breakCMEAgri			= new TimeSpan(4,45,0);
		private  TimeSpan			breakNYMEX				= new TimeSpan(0,45,0);
		private  TimeSpan			breakNYBOT				= new TimeSpan(6,30,0);
		private  TimeSpan			breakNYBOTRussell		= new TimeSpan(2,0,0);
		private  TimeSpan			breakIPE				= new TimeSpan(2,0,0);
		private  TimeSpan			breakEUREX				= new TimeSpan(0,0,0);
		private  TimeSpan			breakLocal				= new TimeSpan(0,0,0);
		private int					lastYear				= 2019;
		private DateTime[]			beginDST				= new DateTime[100];
		private	DateTime[]			endDST					= new DateTime[100];

        private int stb_avgLength = 5;
        private int stb_avgCounter = 0;
        private DateTime[] stb_sessionDates;
        private double[] stb_sessionCloses;
        private double[] stb_sessionHighs;
        private double[] stb_sessionLows;
        private bool showMethods = false;

		#endregion

		/// <summary>
		/// This method is used to configure the indicator and is called once before any bar data is loaded.
		/// </summary>
		protected override void Initialize()
		{
			Add(new Plot(new Pen(Color.SteelBlue,1), PlotStyle.Line,"D-PP "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R1 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S1 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R2 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S2 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R3 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S3 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R4 "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S4 "));
			
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-RMid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-SMid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R12Mid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S12Mid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R23Mid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S23Mid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-R34Mid "));
			Add(new Plot(new Pen(Color.DeepSkyBlue,1), PlotStyle.Line,"D-S34Mid "));
			
			Add(new Plot(new Pen(Color.Transparent,1), PlotStyle.Line,"YD-Open "));
			Add(new Plot(new Pen(Color.Lime,1), PlotStyle.Dot,"YD-High "));
			Add(new Plot(new Pen(Color.OrangeRed,1), PlotStyle.Dot,"YD-Low "));
			Add(new Plot(new Pen(Color.Yellow,1), PlotStyle.Dot,"YD-Close "));
			Add(new Plot(new Pen(Color.Blue,1), PlotStyle.Line,"YD-Mid "));

            Add(new Plot(new Pen(Color.Gray, 1), PlotStyle.Line, "YD-VWAP"));

			Plots[0].Pen.DashStyle = DashStyle.Dash;
			Plots[1].Pen.DashStyle = DashStyle.Dot;
            Plots[2].Pen.DashStyle = DashStyle.Dot;
            Plots[3].Pen.DashStyle = DashStyle.Dot;
            Plots[4].Pen.DashStyle = DashStyle.Dot;
            Plots[5].Pen.DashStyle = DashStyle.Dot;
            Plots[6].Pen.DashStyle = DashStyle.Dot;
            Plots[7].Pen.DashStyle = DashStyle.Dot;
            Plots[8].Pen.DashStyle = DashStyle.Dot;
            Plots[9].Pen.DashStyle = DashStyle.Dot;
            Plots[10].Pen.DashStyle = DashStyle.Dot;
            Plots[11].Pen.DashStyle = DashStyle.Dot;
            Plots[12].Pen.DashStyle = DashStyle.Dot;
            Plots[13].Pen.DashStyle = DashStyle.Dot;
            Plots[14].Pen.DashStyle = DashStyle.Dot;
            Plots[15].Pen.DashStyle = DashStyle.Dot;
            Plots[16].Pen.DashStyle = DashStyle.Dot;
			Plots[17].Pen.DashStyle = DashStyle.Dash;
			Plots[18].Pen.DashStyle = DashStyle.Dash;
			Plots[19].Pen.DashStyle = DashStyle.Dash;
			Plots[20].Pen.DashStyle = DashStyle.Dash;
			Plots[21].Pen.DashStyle = DashStyle.Dash;
			Plots[22].Pen.DashStyle = DashStyle.Dash;
			
			CalculateOnBarClose				= true;     
			AutoScale						= false;
			Overlay							= true;
			stringFormatNear.Alignment 		= StringAlignment.Near;
			stringFormatCenter.Alignment 	= StringAlignment.Center;
			stringFormatFar.Alignment		= StringAlignment.Far;
			
			// Defining all instruments for which this indicator can be used. Indicator will not show on any instruments not listed here!
			
			if(Instrument == null)
				return;
			
			if (localSession)
			{
				breakLength = breakLocal;
				sessionEnd = endLocal + breakLocal;
				sessionBegin = beginLocal;
				local = true;
			}
			else if (Instrument.MasterInstrument.InstrumentType == Cbi.InstrumentType.Currency)
			{
				breakLength = breakFOREX;
				sessionEnd = endFOREX + breakFOREX;
				sessionBegin = beginFOREX;
				newyork = true;
				exFOREX = true;
			}	
			else if (Instrument.MasterInstrument.Name == "ES"||Instrument.MasterInstrument.Name == "EMD"||Instrument.MasterInstrument.Name == "YM"
				||Instrument.MasterInstrument.Name == "NQ" ||Instrument.MasterInstrument.Name == "SP500"||Instrument.MasterInstrument.Name == "NDX"
				||Instrument.MasterInstrument.Name == "RUT" ||Instrument.MasterInstrument.Name == "DJIA"||Instrument.MasterInstrument.Name == "NYA")
			{
				breakLength = breakCMEIndex;
				sessionEnd = endCMEIndex + breakCMEIndex;
				sessionBegin = beginCMEIndex;
				chicago = true;
				exCMEIndex = true;
			}
			else if (Instrument.MasterInstrument.Name == "ZB"||Instrument.MasterInstrument.Name == "ZN"||Instrument.MasterInstrument.Name == "ZF"
				||Instrument.MasterInstrument.Name == "ZT")
			{
				breakLength = breakCMEInterest;
				sessionEnd = endCMEInterest + breakCMEInterest;
				sessionBegin = beginCMEInterest;
				chicago = true;
				exCMEInterest = true;
			}
			else if (Instrument.MasterInstrument.Name == "6A"||Instrument.MasterInstrument.Name == "6B"||Instrument.MasterInstrument.Name == "6C"
				||Instrument.MasterInstrument.Name == "6E"||Instrument.MasterInstrument.Name == "6J"||Instrument.MasterInstrument.Name == "6S")
			{
				breakLength = breakCMEForex;
				sessionEnd = endCMEForex + breakCMEForex;
				sessionBegin = beginCMEForex;
				chicago = true;
				exCMEForex = true;
			}
			else if (Instrument.MasterInstrument.Name == "ZC"||Instrument.MasterInstrument.Name == "ZL"||Instrument.MasterInstrument.Name == "ZM"
				||Instrument.MasterInstrument.Name == "ZS"||Instrument.MasterInstrument.Name == "ZW")
			{
				breakLength = breakCMEAgri;
				sessionEnd = endCMEAgri + breakCMEAgri;
				sessionBegin = beginCMEAgri;
				chicago = true;
				exCMEAgri = true;
			}
			else if (Instrument.MasterInstrument.Name == "CL"||Instrument.MasterInstrument.Name == "HO"||Instrument.MasterInstrument.Name == "RB"
				||Instrument.MasterInstrument.Name == "NG"||Instrument.MasterInstrument.Name == "GC"||Instrument.MasterInstrument.Name == "SI"
				||Instrument.MasterInstrument.Name == "HG"||Instrument.MasterInstrument.Name == "QM")
			{
				breakLength = breakNYMEX;
				sessionEnd = endNYMEX + breakNYMEX;
				sessionBegin = beginNYMEX;
				newyork = true;
				exNYMEX = true;
			}
			else if (Instrument.MasterInstrument.Name == "CC"||Instrument.MasterInstrument.Name == "CT"||Instrument.MasterInstrument.Name == "KC"
				||Instrument.MasterInstrument.Name == "SB")
			{
				breakLength = breakNYBOT;
				sessionEnd = endNYBOT + breakNYBOT;
				sessionBegin = beginNYBOT;
				newyork = true;
				exNYBOT = true;
			}
			else if (Instrument.MasterInstrument.Name == "TF")
			{
				breakLength = breakNYBOTRussell;
				sessionEnd = endNYBOTRussell + breakNYBOTRussell;
				sessionBegin = beginNYBOTRussell;
				newyork = true;
				exNYBOTRussell = true;
			}
			else if (Instrument.MasterInstrument.Name == "COIL"||Instrument.MasterInstrument.Name == "GOIL"||Instrument.MasterInstrument.Name == "WTI")
			{
				breakLength = breakIPE;
				sessionEnd = endIPE +breakIPE;
				sessionBegin = beginIPE;
				newyork = true;
				exIPE = true;
			}
			else if (Instrument.MasterInstrument.Name == "FDAX"||Instrument.MasterInstrument.Name == "FESX"||Instrument.MasterInstrument.Name == "FGBL"
				||Instrument.MasterInstrument.Name == "FGBM")
			{
				breakLength = breakEUREX;
				sessionEnd = endEUREX + breakEUREX;
				sessionBegin = beginEUREX;
				frankfurt = true;
				exEUREX = true;
			}
			
			if (sessionBegin == new TimeSpan(0,0,0))
				sessionBegin = new TimeSpan(24,0,0);
			if (sessionEnd == new TimeSpan(0,0,0))
				sessionEnd = new TimeSpan(24,0,0);
			if (sessionEnd > sessionBegin) 
				sessionLength = sessionEnd-sessionBegin;
			else if (sessionEnd < sessionBegin)
				sessionLength = sessionEnd-sessionBegin+daySpan;
			else
				sessionLength = daySpan;
			
			/// Calculating Daylight Saving Time
			
			if (local) 
				for (int year = 2000; year <= lastYear; year++)
				{	
					beginDST[year-2000] = Cbi.Globals.MaxDate;
					endDST[year-2000] = Cbi.Globals.MinDate;
				}
			else if (newyork)
				for (int year = 2000; year <= lastYear; year++)
				{	
					if (year<=2007) beginDST[year-2000] = new DateTime(year,4,7-(5*year/4+4)%7,7,0,0);
					if (year<=2006) endDST[year-2000] = new DateTime(year,10,31-(5*year/4+1)%7,7,0,0);
					if (year>2007) beginDST[year-2000] = new DateTime(year,3,14-(5*year/4+1)%7,7,0,0);
					if (year>2006) endDST[year-2000] = new DateTime(year,11,7-(5*year/4+1)%7,7,0,0);
			 	}
			else if (chicago)
				for (int year = 2000; year <= lastYear; year++)
				{	
					if (year<=2007) beginDST[year-2000] = new DateTime(year,4,7-(5*year/4+4)%7,8,0,0);
					if (year<=2006) endDST[year-2000] = new DateTime(year,10,31-(5*year/4+1)%7,8,0,0);
					if (year>2007) beginDST[year-2000] = new DateTime(year,3,14-(5*year/4+1)%7,8,0,0);
					if (year>2006) endDST[year-2000] = new DateTime(year,11,7-(5*year/4+1)%7,7,8,0);
			 	}
				else if (london)
				for (int year = 2000; year <= lastYear; year++)
				{	
					beginDST[year-2000] = new DateTime(year,3,31-(5*year/4+4)%7,1,0,0);
					endDST[year-2000] = new DateTime(year,10,31-(5*year/4+1)%7,1,0,0);
				}
			else if (frankfurt)
				for (int year = 2000; year <= lastYear; year++)
				{	
					beginDST[year-2000] = new DateTime(year,3,31-(5*year/4+4)%7,1,0,0);
					endDST[year-2000] = new DateTime(year,10,31-(5*year/4+1)%7,1,0,0);
				}
			else				
				instrumentfound = false;

            // _e_
            stb_sessionDates = new DateTime[stb_avgLength];
            stb_sessionCloses = new double[stb_avgLength];
            stb_sessionHighs = new double[stb_avgLength];
            stb_sessionLows = new double[stb_avgLength];

		}

		/// <summary>
		/// Called on each bar uPDDate event (incoming tick)
		/// </summary>
		protected override void OnBarUpdate()
		{
			if (Bars == null)
				return; 
            if (!Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday && Bars.Period.Id != PeriodType.Day)
				return;
			if (!instrumentfound)
			{
				textBrush.Color = ChartControl.AxisColor;
				DrawTextFixed("errortag1", errorData1, TextPosition.Center, textBrush.Color, textFont, Color.Transparent,Color.Transparent,0);
				return;
			}	
			if (Bars.Period.Id == PeriodType.Day && pivotRangeType == PivotRange.Daily)
			{
				textBrush.Color = ChartControl.AxisColor;
				DrawTextFixed("errortag2", errorData2, TextPosition.Center, textBrush.Color, textFont, Color.Transparent,Color.Transparent,0);
				return;
			}
			if (Bars.Period.Id == PeriodType.Day && Bars.Period.Value > 1)
				return;
			if (showInstructions && priorDayHLC == HLCCalculationMode.CalcFromIntradayData && Bars.Period.Id == PeriodType.Range)
			{
				textBrush.Color = ChartControl.AxisColor;
				DrawTextFixed("errortag5", errorData5, TextPosition.BottomRight, textBrush.Color, textFont2, Color.Transparent,Color.Transparent,0);
			}	
			if (showInstructions && priorDayHLC == HLCCalculationMode.CalcFromIntradayData 
				&& (Bars.Period.Id == PeriodType.Minute && Bars.Period.Value > Math.Max(1,breakLength.Minutes + 60 * breakLength.Hours)))
			{
				textBrush.Color = ChartControl.AxisColor;
				DrawTextFixed("errortag6", errorData6, TextPosition.BottomRight, textBrush.Color, textFont2, Color.Transparent,Color.Transparent,0);
			}
			if (showInstructions && priorDayHLC == HLCCalculationMode.CalcFromIntradayData 
				&& (Bars.Period.Id == PeriodType.Tick || Bars.Period.Id == PeriodType.Volume))
			{
				textBrush.Color = ChartControl.AxisColor;
				DrawTextFixed("errortag7", errorData7, TextPosition.BottomRight, textBrush.Color, textFont2, Color.Transparent,Color.Transparent,0);
			}
			if (dailyDataNotLoaded)
				return;

            //if (CalculateOnBarClose == false && FirstTickOfBar == false)            // _e_
            //    return;

			if (!isDailyDataLoaded && !isInitializing)
			{
				isInitializing = true;
				if (priorDayHLC == HLCCalculationMode.DailyBars && Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday) 
				{
					dailyBars = Data.Bars.GetBars(Bars.Instrument, new Period(PeriodType.Day, 1, MarketDataType.Last), Bars.From, Bars.To, (Session) Bars.Session.Clone(), Data.Bars.SplitAdjust, Data.Bars.DividendAdjust);
					if (dailyBars.Count <= 1)
					{
						existsHistDailyData = false;
						textBrush.Color = ChartControl.AxisColor;
						DrawTextFixed("errortag4", errorData4, TextPosition.Center, textBrush.Color, textFont, Color.Transparent,Color.Transparent,0);
						dailyDataNotLoaded = true;
						return;
					}
					else
					existsHistDailyData = true;
				}
				else 
					existsHistDailyData = false;
				
				isInitializing 	  = false;
				isDailyDataLoaded = true;
			}

			IBar	dailyBar;
			if (existsHistDailyData) 
			{
				DateTime intradayBarTime = Time[0].Date;
				if (Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday)
				{				
					intradayBarTime = ConvertTime(Time[0]);
				}
				dailyBar = dailyBars.Get(dailyBars.GetBar(intradayBarTime.Date));
				
				if (dailyBar.Time.Date > intradayBarTime.Date)
				{
					for (DateTime i = intradayBarTime; i >= dailyBars.Get(0).Time; i = i.AddDays(-1))
					{
						dailyBar = dailyBars.Get(dailyBars.GetBar(i));
						if (dailyBar.Time.Date == i.Date)
							break;
					}
				}
			}
			else
				dailyBar = null;
		
			double	open		= existsHistDailyData ? dailyBar.Open : Open[0];
			double	high		= existsHistDailyData ? dailyBar.High : High[0];
			double	low			= existsHistDailyData ? dailyBar.Low : Low[0];
			double	close		= existsHistDailyData ? dailyBar.Close : Close[0];

            marketTime = Time[0];
            if (Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday)
                marketTime = ConvertTime(marketTime);

            // _e_
            if (showMethods)
            {
                string msgPF = "";
                msgPF = msgPF + "\n" + "Pivot formula: " + pivotFormula;

                string msgBM = "";
                msgBM = msgBM + "\n" + "BM: The markets have a certain inclination to:";
                msgBM = msgBM + "\n" + "1) trade back to the WP";
                msgBM = msgBM + "\n" + "2) trade towards the YH or YL if we open outside that range";
                msgBM = msgBM + "\n" + "3) take out the YH or YL if we open in the range";
                msgBM = msgBM + "\n" + "4) run the ONH and/or ONL";
                msgBM = msgBM + "\n" + "5) break LWH or LWL if we open in that range on the first day of the week";
                msgBM = msgBM + "\n" + "see http://www.mypivots.com/board/topic/6086/-1/es-short-term-trading-9-14-2010";

                string msgBS = "";
                msgBS = msgBS + "\n" + "BS: The first price targets usually are the ONH, ONL, YH, YL, VWAP and DP, depending on:";
                msgBS = msgBS + "\n" + "1) direction, balance between buying and selling sentiment, sector and intermarket dynamics";
                msgBS = msgBS + "\n" + "2) volatility, today's volume relative to yesterday's and the prior five days' average volume";
                msgBS = msgBS + "\n" + "3) risk, trade in the identified direction at a price that provides a favorable level of reward";
                msgBS = msgBS + "\n" + "4) time, hold the trade to the price target most likely to be hit given strength and volatility";
                msgBS = msgBS + "\n" + "see http://traderfeed.blogspot.com/2010/04/bonus-post-2-different-method-for.html";

                string _msgID = "msgWindow";
                string msg = msgPF+ "\n" + msgBM + "\n" + msgBS;
                DrawTextFixed(_msgID, msg, TextPosition.TopLeft, Color.DarkGray, new Font("Arial", 7, FontStyle.Regular), Color.Empty, Color.Empty, 255);
            }

            if (
                (currentDate != Cbi.Globals.MinDate 
                    && pivotRangeType == PivotRange.Daily
                    && marketTime.Date != currentDate
                    && marketTime.DayOfWeek != DayOfWeek.Saturday 
                    && currentDate.DayOfWeek != DayOfWeek.Sunday)
				|| (currentWeek != Cbi.Globals.MinDate && pivotRangeType == PivotRange.Weekly && RoundUpTimeToPeriodTime(marketTime.Date, PivotRange.Weekly) != currentWeek) 
				|| (currentMonth != Cbi.Globals.MinDate && pivotRangeType == PivotRange.Monthly && RoundUpTimeToPeriodTime(marketTime.Date, PivotRange.Monthly) != currentMonth && marketTime.DayOfWeek != DayOfWeek.Saturday && currentDate.DayOfWeek != DayOfWeek.Sunday) 
                || priorDayHLC == HLCCalculationMode.UserDefinedValues
                || (Time[0] == Bars.TimeLastBar)                        // _e_ 
                 )
			{
                if (firstPeriod == false || priorDayHLC == HLCCalculationMode.UserDefinedValues)
				{
                    range = (currentHigh - currentLow);						
					if (PivotFormula == stb_CMIPivotStylesPDS86.Fibonacci)
					{
						pp				= (currentHigh + currentLow + currentClose) / 3;
						s1				= pp - 0.382*range;
						r1				= pp + 0.382*range;
						s2				= pp - 0.614*range;
						r2				= pp + 0.614*range;
						s3				= pp - range;
						r3				= pp + range;
						s4				= pp - 1.382*range;
						r4				= pp + 1.382*range;
					}
					else if (PivotFormula == stb_CMIPivotStylesPDS86.Camarilla)
					{
						pp				= currentClose;
						s1				= currentClose - 1.1/12*range;
						r1				= currentClose + 1.1/12*range;
						s2				= currentClose - 1.1/6*range;
						r2				= currentClose + 1.1/6*range;
						s3				= currentClose - 1.1/4*range;
						r3				= currentClose + 1.1/4*range;
						s4				= currentClose - 1.1/2*range;
						r4				= currentClose + 1.1/2*range;
					}
                    // _e_ BS pivots formula
                    else if (PivotFormula == stb_CMIPivotStylesPDS86.Steenbarger)
                    {
                        // _e_ Get data for BS pivots formula
                        for (int i = 1; i < stb_avgCounter; i++)
                        {
                            stb_sessionDates[stb_avgCounter - i] = stb_sessionDates[stb_avgCounter - i - 1];
                            stb_sessionCloses[stb_avgCounter - i] = stb_sessionCloses[stb_avgCounter - i - 1];
                            stb_sessionHighs[stb_avgCounter - i] = stb_sessionHighs[stb_avgCounter - i - 1];
                            stb_sessionLows[stb_avgCounter - i] = stb_sessionLows[stb_avgCounter - i - 1];
                        }
                        stb_sessionDates[0] = currentDate;
                        stb_sessionCloses[0] = currentClose;
                        stb_sessionHighs[0] = currentHigh;
                        stb_sessionLows[0] = currentLow;
                        stb_avgCounter = Math.Min(stb_avgCounter + 1, stb_avgLength);
                    
                        pp = (currentHigh + currentLow + 2 * currentClose) / 4;
                        double stb_vt = 0;
                        double stb_v = 0;
                        for (int i = 0; i < stb_avgCounter; i++)
                        {
                            stb_vt += (stb_sessionHighs[i] - stb_sessionLows[i]);
                        }
                        stb_v = stb_vt / stb_avgCounter;

                        s1 = pp - 0.6 * stb_v;
                        r1 = pp + 0.6 * stb_v;
                        s2 = pp - 0.8 * stb_v;
                        r2 = pp + 0.8 * stb_v;
                        s3 = pp - 1.0 * stb_v;
                        r3 = pp + 1.0 * stb_v;
                        s4 = pp - 1.2 * stb_v;
                        r4 = pp + 1.2 * stb_v;

                    }
                    else
                    {
                        if (PivotFormula == stb_CMIPivotStylesPDS86.Floor || PivotFormula == stb_CMIPivotStylesPDS86.Wide)
                            pp = (currentHigh + currentLow + currentClose) / 3;
                        else if (PivotFormula == stb_CMIPivotStylesPDS86.Woodies)
                            pp = (currentHigh + currentLow + 2 * currentClose) / 4;

                        s1 = 2 * pp - currentHigh;
                        r1 = 2 * pp - currentLow;
                        s2 = pp - range;
                        r2 = pp + range;
                        if (PivotFormula == stb_CMIPivotStylesPDS86.Floor || PivotFormula == stb_CMIPivotStylesPDS86.Woodies)
                        {
                            s3 = s1 - range;
                            r3 = r1 + range;
                            s4 = s3 - (currentHigh - pp);
                            r4 = r3 + (pp - currentLow);
                        }
                        else if (PivotFormula == stb_CMIPivotStylesPDS86.Wide)
                        {
                            s3 = s2 - range;
                            r3 = r2 + range;
                            s4 = s3 - range;
                            r4 = r3 + range;
                        }
                        smid = 0.5 * (pp + s1);
                        rmid = 0.5 * (pp + r1);
                        s12mid = 0.5 * (s1 + s2);
                        r12mid = 0.5 * (r1 + r2);
                        s23mid = 0.5 * (s2 + s3);
                        r23mid = 0.5 * (r2 + r3);
                        s34mid = 0.5 * (s3 + s4);
                        r34mid = 0.5 * (r3 + r4);
                    }

					previousOpen		= currentOpen;
					previousHigh		= currentHigh;
					previousLow			= currentLow;
					previousClose		= currentClose;
					midline				= (currentHigh + currentLow) / 2;
					if (volSum > double.Epsilon)
						previousVWAP	= volPriceSum/volSum;
					else
						previousVWAP	= 0;
				}                               

				firstPeriod = false;
				sessionOpen = false;
				volSum = 0;
				volPriceSum = 0;
				if (marketTime.TimeOfDay >= daySpan-sessionLength) 
				{
                    currentOpen = (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedOpen : open;
					currentHigh		= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedHigh : high;
					currentLow		= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedLow : low;
					currentClose	= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedClose : close;
					volPriceSum		= Typical[0]*Volume[0];
					volSum			= Volume[0];
					sessionOpen = true;
                }
            }

			if (marketTime.TimeOfDay >= daySpan-sessionLength)      // _e_
			{
                currentClose = (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedClose : close;
				if (sessionOpen == false)
				{
                    currentOpen = (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedOpen : open;
					currentHigh		= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedHigh : high;
					currentLow		= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedLow : low;
					volPriceSum		= Typical[0]*Volume[0];
					volSum			= Volume[0];
					sessionOpen			=  true;	
				}
				else	
				{
                    currentHigh = (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedHigh : Math.Max(currentHigh, high);
					currentLow		= (priorDayHLC == HLCCalculationMode.UserDefinedValues) ? userDefinedLow : Math.Min(currentLow, low);
					volSum			= volSum + Volume[0];
					volPriceSum		= volPriceSum + Typical[0]*Volume[0];
				}
			}

			if (pivotRangeType == PivotRange.Daily)
				currentDate = marketTime.Date;
			if (pivotRangeType == PivotRange.Weekly)
				currentWeek = RoundUpTimeToPeriodTime(marketTime.Date, PivotRange.Weekly);
			if (pivotRangeType == PivotRange.Monthly)
				currentMonth = RoundUpTimeToPeriodTime(marketTime.Date, PivotRange.Monthly);

			if (((pivotRangeType == PivotRange.Daily && currentDate != Cbi.Globals.MinDate)
				|| (pivotRangeType == PivotRange.Weekly && currentWeek != Cbi.Globals.MinDate)
				|| (pivotRangeType == PivotRange.Monthly && currentMonth != Cbi.Globals.MinDate))
                )
			{
                if (PivotFormula != stb_CMIPivotStylesPDS86.Camarilla)
					PP.Set(pp);
				    R1.Set(r1);
				    S1.Set(s1);
				    R2.Set(r2);
				    S2.Set(s2);
				    R3.Set(r3);
				    S3.Set(s3);
				    R4.Set(r4);
				    S4.Set(s4);

				if (showMidpivots && PivotFormula != stb_CMIPivotStylesPDS86.Fibonacci && PivotFormula != stb_CMIPivotStylesPDS86.Camarilla)
				{
					RMid.Set(rmid);
					SMid.Set(smid);
					R12Mid.Set(r12mid);
					S12Mid.Set(s12mid);
					R23Mid.Set(r23mid);
					S23Mid.Set(s23mid);
					R34Mid.Set(r34mid);
					S34Mid.Set(s34mid);
				}
                PreviousOpen.Set(previousOpen);
                PreviousHigh.Set(previousHigh);
                PreviousLow.Set(previousLow);
                PreviousClose.Set(previousClose);

                Midline.Set(midline);
				if (Instrument.MasterInstrument.InstrumentType != Cbi.InstrumentType.Index && 
				 	Instrument.MasterInstrument.InstrumentType != Cbi.InstrumentType.Currency && previousVWAP > double.Epsilon)
					PVWAP.Set(previousVWAP);
				else
					PVWAP.Reset();
			}
		}

		#region Properties

        /// <summary>
        /// </summary>
        [Description("Option to show Methods")]
        [Category("Options")]
        [Gui.Design.DisplayNameAttribute("Show Methods")]
        public bool ShowMethods
        {
            get { return showMethods; }
            set { showMethods = value; }
        }
        
        /// <summary>
		/// </summary>
		///[Description("Type of period for pivot points.")]
		///[Category("Parameters")]
		///public Data.PivotRange PivotRangeType 
		///{
		///	get { return pivotRangeType; }
		///	set { pivotRangeType = value; }
		///}

		/// <summary>
		/// </summary>
		[Description("Approach for calculation the prior day HLC values.")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Prior Day High/Low/Close")]
		public Data.HLCCalculationMode PriorDayHLC
		{
			get { return priorDayHLC; }
			set { priorDayHLC = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Option to show MidPivots")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Show Midpivots")]
		public bool ShowMidpivots 
		{
			get { return showMidpivots; }
			set { showMidpivots = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Option to show Instructions")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Show Instructions")]
		public bool ShowInstructions 
		{
			get { return showInstructions; }
			set { showInstructions = value; }
		}

		/// <summary>
		/// </summary>
		[Description("Option where to plot labels")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Plot Labels")]
		public stb_CMIPlotAlignPDS86 PlotLabels
		{
			get { return plotLabels; }
			set { plotLabels = value; }
		}
			
		/// <summary>
		/// </summary>
		[Description("Pivot Formula Type")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Pivot Formula")]
		public stb_CMIPivotStylesPDS86 PivotFormula
		{
			get { return pivotFormula; }
			set { pivotFormula = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Distance of label from line.")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Label Position")]
		public int LabelPosition
		{
			get { return labelPosition; }
			set { labelPosition = Math.Max(1, value); }
		}
	
		/// <summary>
		/// </summary>
		[Description("Option for Local Session")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Local Session")]
		public bool LocalSession
		{
			get { return localSession; }
			set { localSession = value; }
		}
				
		/// <summary>
		/// </summary>
		[Description("Option for IntraDay Session")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Intraday Session")]
		public bool IntraDaySession
		{
			get { return intraDaySession; }
			set { intraDaySession = value; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PP
		{
			get { return Values[0]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R1
		{
			get { return Values[1]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R2
		{
			get { return Values[3]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R3
		{
			get { return Values[5]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R4
		{
			get { return Values[7]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S1
		{
			get { return Values[2]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S2
		{
			get { return Values[4]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S3
		{
			get { return Values[6]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S4
		{
			get { return Values[8]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries RMid
		{
			get { return Values[9]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R12Mid
		{
			get { return Values[11]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R23Mid
		{
			get { return Values[13]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R34Mid
		{
			get { return Values[15]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SMid
		{
			get { return Values[10]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S12Mid
		{
			get { return Values[12]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S23Mid
		{
			get { return Values[14]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S34Mid
		{
			get { return Values[16]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PreviousOpen
		{
			get { return Values[17]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PreviousHigh
		{
			get { return Values[18]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PreviousLow
		{
			get { return Values[19]; }
		}
			
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PreviousClose
		{
			get { return Values[20]; }
		}
			
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries Midline
		{
			get { return Values[21]; }
		}
			
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PVWAP
		{
			get { return Values[22]; }
		}

		/// <summary>
		/// close value for user defined pivots calculation
		/// </summary>
		[Description("User defined prior session open value used for pivots calculation.")]
		[Category("\rUser defined values")]
		[Gui.Design.DisplayNameAttribute("User Defined Open")]
		public double UserDefinedOpen
		{
			get { return userDefinedOpen; }
			set { userDefinedOpen = value; }
		}

		/// <summary>
		/// high value for user defined pivots calculation
		/// </summary>
		[Description("User defined prior session high value used for pivots calculation.")]
		[Category("\rUser defined values")]
		[Gui.Design.DisplayNameAttribute("User Defined High")]
		public double UserDefinedHigh
		{
			get { return userDefinedHigh; }
			set { userDefinedHigh = value; }
		}

		/// <summary>
		/// low value for user defined pivots calculation
		/// </summary>
		[Description("User defined prior session low value used for pivots calculation.")]
		[Category("\rUser defined values")]
		[Gui.Design.DisplayNameAttribute("User Defined Low")]
		public double UserDefinedLow
		{
			get { return userDefinedLow; }
			set { userDefinedLow = value; }
		}

		/// <summary>
		/// close value for user defined pivots calculation
		/// </summary>
		[Description("User defined prior session close value used for pivots calculation.")]
		[Category("\rUser defined values")]
		[Gui.Design.DisplayNameAttribute("User Defined Close")]
		public double UserDefinedClose
		{
			get { return userDefinedClose; }
			set { userDefinedClose = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Width of the pivot lines as # of bars.")]
		[Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Line Width")]
		public int Width
		{
			get { return width; }
			set { width = Math.Max(1, value); }
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndFOREX
		{
			get { return endFOREX;}
			set { endFOREX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for FOREX markets \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End FOREX (ET)")]
		public string S_End_FOREX_ET	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endFOREX.Hours, endFOREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endFOREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndCMEIndex
		{
			get { return endCMEIndex;}
			set { endCMEIndex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for Globex Index Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End GLOBEX Index")]
		public string S_End_CME_Index	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endCMEIndex.Hours, endCMEIndex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endCMEIndex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndCMEInterest
		{
			get { return endCMEInterest;}
			set { endCMEInterest = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for Globex Interest Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End GLOBEX Interest")]
		public string S_End_CME_Interest	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endCMEInterest.Hours, endCMEInterest.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endCMEInterest = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndCMEForex
		{
			get { return endCMEForex;}
			set { endCMEForex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for Globex Currency Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End GLOBEX Currencies")]
		public string S_End_CME_Forex	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endCMEForex.Hours, endCMEForex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endCMEForex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndCMEAgri
		{
			get { return endCMEAgri;}
			set { endCMEAgri = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for Globex Agricultural Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End GLOBEX Agricultural")]
		public string S_End_CME_Agricultural	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endCMEAgri.Hours, endCMEAgri.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endCMEAgri = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}

		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndNYMEX
		{
			get { return endNYMEX;}
			set { endNYMEX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for NYMEX Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End NYMEX")]
		public string S_End_NYMEX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endNYMEX.Hours, endNYMEX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endNYMEX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndNYBOT
		{
			get { return endNYBOT;}
			set { endNYBOT = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for NYBOT Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End NYBOT")]
		public string S_End_NYBOT	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endNYBOT.Hours, endNYBOT.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endNYBOT = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndNYBOTRussell
		{
			get { return endNYBOTRussell;}
			set { endNYBOTRussell = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for NYBOT Russell Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End NYBOT Russell")]
		public string S_End_NYBOT_Russell	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endNYBOTRussell.Hours, endNYBOTRussell.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endNYBOTRussell = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndIPE
		{
			get { return endIPE;}
			set { endIPE = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for IPE Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End IPE")]
		public string S_End_IPE	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endIPE.Hours, endIPE.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endIPE = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndEUREX
		{
			get { return endEUREX;}
			set { endEUREX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Closing Time for EUREX Futures \nPlease Use Central European Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End EUREX")]
		public string S_End_EUREX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endEUREX.Hours, endEUREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endEUREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan EndLocal
		{
			get { return endLocal;}
			set { endLocal = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Local Session Closing Time for other instruments \nPlease Use Local Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session End LOCAL")]
		public string S_End_Local	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", endLocal.Hours, endLocal.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			endLocal = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginFOREX
		{
			get { return beginFOREX;}
			set { beginFOREX = value;}
		}	
		
		///<summary
		///</summary>
		[Description("Session Opening Time for FOREX markets \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin FOREX (ET)")]
		public string S_Begin_FOREX_ET	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginFOREX.Hours, beginFOREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginFOREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginCMEIndex
		{
			get { return beginCMEIndex;}
			set { beginCMEIndex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for Globex Index Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin GLOBEX Index")]
		public string S_Begin_CME_Index	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginCMEIndex.Hours, beginCMEIndex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginCMEIndex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginCMEInterest
		{
			get { return beginCMEInterest;}
			set { beginCMEInterest = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for Globex Interest Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin GLOBEX Interest")]
		public string S_Begin_CME_Interest	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginCMEInterest.Hours, beginCMEInterest.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginCMEInterest = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginCMEForex
		{
			get { return beginCMEForex;}
			set { beginCMEForex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for Globex Currency Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin GLOBEX Currency")]
		public string S_Begin_CME_Forex	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginCMEForex.Hours, beginCMEForex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginCMEForex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginCMEAgri
		{
			get { return beginCMEAgri;}
			set { beginCMEAgri = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for Globex Agricultural Futures \nPlease Use Central Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin GLOBEX Agricultural")]
		public string S_Begin_CME_Agricultural	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginCMEAgri.Hours, beginCMEAgri.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginCMEAgri = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
	
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginNYMEX
		{
			get { return beginNYMEX;}
			set { beginNYMEX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for NYMEX Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin NYMEX")]
		public string S_Begin_NYMEX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginNYMEX.Hours, beginNYMEX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginNYMEX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginNYBOT
		{
			get { return beginNYBOT;}
			set { beginNYBOT = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for NYBOT Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin NYBOT")]
		public string S_Begin_NYBOT	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginNYBOT.Hours, beginNYBOT.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginNYBOT = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
			
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginNYBOTRussell
		{
			get { return beginNYBOTRussell;}
			set { beginNYBOTRussell = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for NYBOT Russell Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin NYBOT Russell")]
		public string S_Begin_NYBOT_Russell	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginNYBOTRussell.Hours, beginNYBOTRussell.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginNYBOTRussell = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginIPE
		{
			get { return beginIPE;}
			set { beginIPE = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for IPE Futures \nPlease Use Eastern Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin IPE")]
		public string S_Begin_IPE	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginIPE.Hours, beginIPE.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginIPE = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginEUREX
		{
			get { return beginEUREX;}
			set { beginEUREX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Session Opening Time for EUREX Futures \nPlease Use Central European Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin EUREX")]
		public string S_Begin_EUREX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginEUREX.Hours, beginEUREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginEUREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
			
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BeginLocal
		{
			get { return beginLocal;}
			set { beginLocal = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Local Session Opening Time for other instruments \nPlease Use Local Time!")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Session Begin LOCAL")]
		public string S_Begin_Local	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", beginLocal.Hours, beginLocal.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			beginLocal = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakFOREX
		{
			get { return breakFOREX;}
			set { breakFOREX = value;}
		}	
		
		///<summary
		///</summary>
		[Description("Duration of break for FOREX markets")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period FOREX")]
		public string S_Break_FOREX_ET	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakFOREX.Hours, breakFOREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakFOREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakCMEIndex
		{
			get { return breakCMEIndex;}
			set { breakCMEIndex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for Globex Index Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period GLOBEX Index")]
		public string S_Break_CME_Index	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakCMEIndex.Hours, breakCMEIndex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakCMEIndex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakCMEInterest
		{
			get { return breakCMEInterest;}
			set { breakCMEInterest = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for Globex Interest Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period GLOBEX Interest")]
		public string S_Break_CME_Interest	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakCMEInterest.Hours, breakCMEInterest.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakCMEInterest = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakCMEForex
		{
			get { return breakCMEForex;}
			set { breakCMEForex = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for Globex Currency Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period GLOBEX Currency")]
		public string S_Break_CME_Forex	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakCMEForex.Hours, breakCMEForex.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakCMEForex = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
				
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakCMEAgri
		{
			get { return breakCMEAgri;}
			set { breakCMEAgri = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for Globex Agricultural Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period GLOBEX Agricultural")]
		public string S_Break_CME_Agricultural	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakCMEAgri.Hours, breakCMEAgri.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakCMEAgri = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
	
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakNYMEX
		{
			get { return breakNYMEX;}
			set { breakNYMEX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for NYMEX Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period NYMEX")]
		public string S_Break_NYMEX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakNYMEX.Hours, breakNYMEX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakNYMEX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakNYBOT
		{
			get { return breakNYBOT;}
			set { breakNYBOT = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for NYBOT Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period NYBOT")]
		public string S_Break_NYBOT	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakNYBOT.Hours, breakNYBOT.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakNYBOT = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
			
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakNYBOTRussell
		{
			get { return breakNYBOTRussell;}
			set { breakNYBOTRussell = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for NYBOT Russell Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period NYBOT Russell")]
		public string S_Break_NYBOT_Russell	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakNYBOTRussell.Hours, breakNYBOTRussell.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakNYBOTRussell = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakIPE
		{
			get { return breakIPE;}
			set { breakIPE = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for IPE Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period IPE")]
		public string S_Break_IPE	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakIPE.Hours, breakIPE.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakIPE = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakEUREX
		{
			get { return breakEUREX;}
			set { breakEUREX = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for EUREX Futures")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period EUREX")]
		public string S_Break_EUREX	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakEUREX.Hours, breakEUREX.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakEUREX = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
			
		///<summary
		///</summary>
		[XmlIgnore]
		[Browsable(false)]
		public TimeSpan BreakLocal
		{
			get { return breakLocal;}
			set { breakLocal = value;}
		}	
	
		///<summary
		///</summary>
		[Description("Duration of break for other instruments")]
		[Category("User defined values")]
		[Gui.Design.DisplayNameAttribute("Break Period LOCAL")]
		public string S_Break_Local	
		{
			get 
			{ 
				return string.Format("{0:D2}:{1:D2}", breakLocal.Hours, breakLocal.Minutes);
			}
			set 
			{ 
			string[]values =((string)value).Split(':');
			breakLocal = new TimeSpan(Convert.ToInt16(values[0]),Convert.ToInt16(values[1]),0);
			}
		}
		
		#endregion
		

		#region Miscellaneous

		private DateTime RoundUpTimeToPeriodTime(DateTime time, PivotRange pivotRange)
			
			/// simplified
		{
			if (pivotRange == PivotRange.Weekly)
			{
				return  time.AddDays(6 - Convert.ToInt16(time.DayOfWeek)).Date;
			}
			else if (pivotRange == PivotRange.Monthly)
			{
				DateTime result = new DateTime(time.Year, time.Month, 1); 
				return result.AddMonths(1).AddDays(-1);
			}
			else
				return time;
		}
		
		/// <summary>
		/// </summary>
		/// <param name="graphics"></param>
		/// <param name="bounds"></param>
		/// <param name="min"></param>
		/// <param name="max"></param>
		public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
		{
			if (Bars == null || ChartControl == null)
				return;

			DateTime firstBarTime = Bars.Get(0).Time;
            //#if NT7
                DateTime lastBarTime = Bars.Get(Math.Min(Bars.Count - 1, this.LastBarIndexPainted)).Time;      // _e_
            //#else
                //DateTime lastBarTime = Bars.Get(Math.Min(Bars.Count - 1, ChartControl.LastBarPainted)).Time;      // _e_
            //#endif            

            if 	(Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday)
			{
				firstBarTime = ConvertTime(firstBarTime);
				lastBarTime = ConvertTime(lastBarTime);
			}
			
			// plot error if data not complete
			if (textBrush.Color != ChartControl.AxisColor)
				textBrush.Color = ChartControl.AxisColor;
			if (((pivotRangeType == PivotRange.Monthly && Bars.Count > 0 && RoundUpTimeToPeriodTime(firstBarTime.Date, PivotRange.Monthly).AddMonths(1) >= lastBarTime.Date)
				|| (pivotRangeType == PivotRange.Weekly && Bars.Count > 0 && RoundUpTimeToPeriodTime(firstBarTime.Date, PivotRange.Weekly).AddDays(7) >= lastBarTime.Date)
			    || (pivotRangeType == PivotRange.Daily && Bars.Count > 0 && ((firstBarTime.Date.DayOfWeek == DayOfWeek.Friday)? firstBarTime.Date.AddDays(3): firstBarTime.Date.AddDays(1)) >= lastBarTime.Date))
				&& priorDayHLC != HLCCalculationMode.UserDefinedValues)
				graphics.DrawString(errorData3, textFont, textBrush, bounds.X + bounds.Width/2, bounds.Y + bounds.Height/2, stringFormatCenter);

			int	barWidth = ChartControl.ChartStyle.GetBarPaintWidth(ChartControl.BarWidth);
			for (int seriesCount = 0; seriesCount < Values.Length; seriesCount++)
			{
				SolidBrush		brush				= brushes[seriesCount];
				DateTime		lastDate			= Cbi.Globals.MinDate;
				DateTime		lastWeek			= Cbi.Globals.MinDate;
				DateTime		lastMonth			= Cbi.Globals.MinDate;
				int				lastX				= -1;
				int				lastY				= -1;
				int 			firstX				= -1;
				SmoothingMode	oldSmoothingMode	= graphics.SmoothingMode;
				GraphicsPath	path				= new GraphicsPath();
				Gui.Chart.Plot	plot				= Plots[seriesCount];
				DataSeries	series					= (DataSeries) Values[seriesCount];

				if (brush.Color != plot.Pen.Color)	
					brush = new SolidBrush(plot.Pen.Color);

				for (int count = ChartControl.BarsPainted - 1; count >= ChartControl.BarsPainted - Math.Min(ChartControl.BarsPainted, Width); count--)
				{
                    //#if NT7
                        int whiteBars = Math.Max(0, this.LastBarIndexPainted - ChartControl.Bars[0].Count + 1);
                        int idx = this.LastBarIndexPainted - whiteBars - ChartControl.BarsPainted + 1 + count;                    
                    //#else
                        //int whiteBars = Math.Max(0, ChartControl.LastBarPainted - ChartControl.Bars[0].Count + 1);
					    //int idx = ChartControl.LastBarPainted - whiteBars - ChartControl.BarsPainted + 1 + count;                    
                    //#endif            

					if (idx - Displacement < 0 || idx - Displacement >= Bars.Count || (!ChartControl.ShowBarsRequired && idx - Displacement < BarsRequired))
						continue;
					else if (!series.IsValidPlot(idx))
						continue;
					
						DateTime barTime = Bars.Get(idx).Time;
						if 	(Data.BarsType.GetInstance(Bars.Period.Id).IsIntraday)
							barTime = ConvertTime(barTime);
						if (pivotRangeType == PivotRange.Daily && lastDate == Cbi.Globals.MinDate) 
							lastDate = barTime.Date;
						else if (pivotRangeType == PivotRange.Weekly && lastWeek == Cbi.Globals.MinDate) 
							lastWeek = RoundUpTimeToPeriodTime(barTime.Date, PivotRange.Weekly);
						else if (pivotRangeType == PivotRange.Monthly && lastMonth == Cbi.Globals.MinDate) 
							lastMonth = RoundUpTimeToPeriodTime(barTime.Date, PivotRange.Monthly);
						else if (pivotRangeType == PivotRange.Daily && lastDate != barTime.AddSeconds(1).Date 
								|| pivotRangeType == PivotRange.Weekly && lastWeek != RoundUpTimeToPeriodTime(barTime.Date, PivotRange.Weekly)
								|| pivotRangeType == PivotRange.Monthly && lastMonth != RoundUpTimeToPeriodTime(barTime.Date, PivotRange.Monthly))
							continue;

					double		val = series.Get(idx);
					int			x	= (int) (ChartControl.CanvasRight - ChartControl.BarMarginRight - barWidth / 2
										- (ChartControl.BarsPainted - 1) * ChartControl.BarSpace + (count - whiteBars) * ChartControl.BarSpace);
					int			y	= (int) ((bounds.Y + bounds.Height) - ((val - min ) / Gui.Chart.ChartControl.MaxMinusMin(max, min)) * bounds.Height);

					if (lastX >= 0)
					{
						if (y != lastY) // Problem here is, that last bar of old day has date of new day
							y = lastY;
						path.AddLine(lastX - plot.Pen.Width / 2, lastY, x - plot.Pen.Width / 2, y);
					}
					lastX	= x;
					lastY	= y;
					if (count == ChartControl.BarsPainted - 1)
						firstX	= x;
					if (count == ChartControl.BarsPainted - 2)
						firstX	= x;
				}

				graphics.SmoothingMode = SmoothingMode.AntiAlias;
				graphics.DrawPath(plot.Pen, path);
				graphics.SmoothingMode = oldSmoothingMode;
				if (PlotLabels == stb_CMIPlotAlignPDS86.Right)
				graphics.DrawString(plot.Name, ChartControl.Font, brush, firstX + LabelPosition + 20, lastY - ChartControl.Font.GetHeight() / 2, stringFormatNear);
				if (PlotLabels == stb_CMIPlotAlignPDS86.Left)
				graphics.DrawString(plot.Name, ChartControl.Font, brush, lastX - LabelPosition, lastY - ChartControl.Font.GetHeight() / 2, stringFormatFar);
			}
		}

		private DateTime ConvertTime(DateTime time)
		{
			TimeSpan		localTimeChicago			= new TimeSpan(-6,0,0);
			TimeSpan		localTimeNewYork			= new TimeSpan(-5,0,0);
			TimeSpan		localTimeLondon				= new TimeSpan(0,0,0);
			TimeSpan		localTimeFrankfurt			= new TimeSpan(1,0,0);

			DateTime 		inputTime 				= time;
			
			if (local)
				time = time.AddSeconds(-1);
			else
                time = time.ToUniversalTime().AddSeconds(-1);
			
			if (time.Year > lastYear)
				return inputTime;
			
			if ( time > beginDST[time.Year-2000] && time < endDST[time.Year-2000])
					time = time + new TimeSpan (1,0,0);
			
			if(local)
			{
				if (intraDaySession)
					return time = time - sessionEnd;
				else
					return time = time.AddDays(1) - sessionEnd;
			}
			else if (exFOREX)
			{	
				if (intraDaySession)
					return time = time + localTimeNewYork - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeNewYork - sessionEnd;
			}
			else if (exCMEIndex)
			{	
				if (intraDaySession)
					return time = time + localTimeChicago - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeChicago - sessionEnd;
			}
			else if (exCMEInterest)
			{	
				if (intraDaySession)
					return time = time + localTimeChicago - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeChicago - sessionEnd;
			}
			else if (exCMEForex)
			{	
				if (intraDaySession)
					return time = time + localTimeChicago - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeChicago - sessionEnd;
			}
			else if (exCMEAgri)
			{	
				if (intraDaySession)
					return time = time + localTimeChicago - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeChicago - sessionEnd;
			}
			else if (exNYMEX)
			{	
				if (intraDaySession)
					return time = time + localTimeNewYork - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeNewYork - sessionEnd;
			}
			else if (exNYBOT)
			{	
				if (intraDaySession)
					return time = time + localTimeNewYork - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeNewYork - sessionEnd;
			}
			else if (exNYBOTRussell)
			{	
				if (intraDaySession)
					return time = time + localTimeNewYork - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeNewYork - sessionEnd;
			}
			else if (exIPE)
			{	
				if (intraDaySession)
					return time = time + localTimeNewYork - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeNewYork - sessionEnd;
			}
			else if (exEUREX)
			{	
				if (intraDaySession)
					return time = time + localTimeFrankfurt - sessionEnd;
				else
					return time = time.AddDays(1) + localTimeFrankfurt - sessionEnd;
			}
			else
				return inputTime;
		}	
		#endregion
	}
}



#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private stb_CMIPivotsDaySessionV86[] cachestb_CMIPivotsDaySessionV86 = null;

        private static stb_CMIPivotsDaySessionV86 checkstb_CMIPivotsDaySessionV86 = new stb_CMIPivotsDaySessionV86();

        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        public stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            return stb_CMIPivotsDaySessionV86(Input, intraDaySession, labelPosition, localSession, pivotFormula, plotLabels, priorDayHLC, showInstructions, showMidpivots, width);
        }

        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        public stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(Data.IDataSeries input, bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            checkstb_CMIPivotsDaySessionV86.IntraDaySession = intraDaySession;
            intraDaySession = checkstb_CMIPivotsDaySessionV86.IntraDaySession;
            checkstb_CMIPivotsDaySessionV86.LabelPosition = labelPosition;
            labelPosition = checkstb_CMIPivotsDaySessionV86.LabelPosition;
            checkstb_CMIPivotsDaySessionV86.LocalSession = localSession;
            localSession = checkstb_CMIPivotsDaySessionV86.LocalSession;
            checkstb_CMIPivotsDaySessionV86.PivotFormula = pivotFormula;
            pivotFormula = checkstb_CMIPivotsDaySessionV86.PivotFormula;
            checkstb_CMIPivotsDaySessionV86.PlotLabels = plotLabels;
            plotLabels = checkstb_CMIPivotsDaySessionV86.PlotLabels;
            checkstb_CMIPivotsDaySessionV86.PriorDayHLC = priorDayHLC;
            priorDayHLC = checkstb_CMIPivotsDaySessionV86.PriorDayHLC;
            checkstb_CMIPivotsDaySessionV86.ShowInstructions = showInstructions;
            showInstructions = checkstb_CMIPivotsDaySessionV86.ShowInstructions;
            checkstb_CMIPivotsDaySessionV86.ShowMidpivots = showMidpivots;
            showMidpivots = checkstb_CMIPivotsDaySessionV86.ShowMidpivots;
            checkstb_CMIPivotsDaySessionV86.Width = width;
            width = checkstb_CMIPivotsDaySessionV86.Width;

            if (cachestb_CMIPivotsDaySessionV86 != null)
                for (int idx = 0; idx < cachestb_CMIPivotsDaySessionV86.Length; idx++)
                    if (cachestb_CMIPivotsDaySessionV86[idx].IntraDaySession == intraDaySession && cachestb_CMIPivotsDaySessionV86[idx].LabelPosition == labelPosition && cachestb_CMIPivotsDaySessionV86[idx].LocalSession == localSession && cachestb_CMIPivotsDaySessionV86[idx].PivotFormula == pivotFormula && cachestb_CMIPivotsDaySessionV86[idx].PlotLabels == plotLabels && cachestb_CMIPivotsDaySessionV86[idx].PriorDayHLC == priorDayHLC && cachestb_CMIPivotsDaySessionV86[idx].ShowInstructions == showInstructions && cachestb_CMIPivotsDaySessionV86[idx].ShowMidpivots == showMidpivots && cachestb_CMIPivotsDaySessionV86[idx].Width == width && cachestb_CMIPivotsDaySessionV86[idx].EqualsInput(input))
                        return cachestb_CMIPivotsDaySessionV86[idx];

            stb_CMIPivotsDaySessionV86 indicator = new stb_CMIPivotsDaySessionV86();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.IntraDaySession = intraDaySession;
            indicator.LabelPosition = labelPosition;
            indicator.LocalSession = localSession;
            indicator.PivotFormula = pivotFormula;
            indicator.PlotLabels = plotLabels;
            indicator.PriorDayHLC = priorDayHLC;
            indicator.ShowInstructions = showInstructions;
            indicator.ShowMidpivots = showMidpivots;
            indicator.Width = width;
            indicator.SetUp();

            stb_CMIPivotsDaySessionV86[] tmp = new stb_CMIPivotsDaySessionV86[cachestb_CMIPivotsDaySessionV86 == null ? 1 : cachestb_CMIPivotsDaySessionV86.Length + 1];
            if (cachestb_CMIPivotsDaySessionV86 != null)
                cachestb_CMIPivotsDaySessionV86.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cachestb_CMIPivotsDaySessionV86 = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            return _indicator.stb_CMIPivotsDaySessionV86(Input, intraDaySession, labelPosition, localSession, pivotFormula, plotLabels, priorDayHLC, showInstructions, showMidpivots, width);
        }

        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        public Indicator.stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(Data.IDataSeries input, bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            return _indicator.stb_CMIPivotsDaySessionV86(input, intraDaySession, labelPosition, localSession, pivotFormula, plotLabels, priorDayHLC, showInstructions, showMidpivots, width);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            return _indicator.stb_CMIPivotsDaySessionV86(Input, intraDaySession, labelPosition, localSession, pivotFormula, plotLabels, priorDayHLC, showInstructions, showMidpivots, width);
        }

        /// <summary>
        /// stb_CMIPivotsDaySessionV86.
        /// </summary>
        /// <returns></returns>
        public Indicator.stb_CMIPivotsDaySessionV86 stb_CMIPivotsDaySessionV86(Data.IDataSeries input, bool intraDaySession, int labelPosition, bool localSession, stb_CMIPivotStylesPDS86 pivotFormula, stb_CMIPlotAlignPDS86 plotLabels, Data.HLCCalculationMode priorDayHLC, bool showInstructions, bool showMidpivots, int width)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.stb_CMIPivotsDaySessionV86(input, intraDaySession, labelPosition, localSession, pivotFormula, plotLabels, priorDayHLC, showInstructions, showMidpivots, width);
        }

    }
}
#endregion
